
package de.ivu.elect.business.stimmeingabe.boundary;

import javax.enterprise.context.RequestScoped;
import javax.inject.Inject;
import javax.inject.Named;

import org.apache.deltaspike.core.api.scope.ConversationGroup;

import de.ivu.elect.business.stimmeingabe.entity.StimmeingabePlausiKonfiguration;

@RequestScoped
@Named(StimmeingabePlausiKonfigurationConversationSelect.COMPONENT_NAME)
public class StimmeingabePlausiKonfigurationConversationSelect implements java.io.Serializable {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "stimmeingabePlausiKonfigurationConversationSelect";

  @Inject
  protected transient StimmeingabePlausiKonfigurationExtendedDAO entityDAO;

  @Inject
  @ConversationGroup(StimmeingabePlausiKonfigurationConversationStore.class)
  protected transient StimmeingabePlausiKonfigurationConversationStore conversationStore;

  public StimmeingabePlausiKonfigurationConversationSelect() {
    super();
  }

  public boolean isSelected() {
    return getEntityPK() != null;
  }

  public StimmeingabePlausiKonfiguration getEntity() {
    return getEntityInternal();
  }

  private StimmeingabePlausiKonfiguration getEntityInternal() {
    if (getEntityPK() == null) {
      return null;
    }

    return attach(getEntityPK());
  }

  public void setEntity(StimmeingabePlausiKonfiguration entity) {
    setEntityAttached(attach(entity));
  }

  public void setEntity( de.ivu.elect.business.stimmeingabe.entity.StimmeingabePlausiKonfigurationPK  pk) {
    setEntityAttached(attach(pk));
  }

  protected void setEntityAttached(StimmeingabePlausiKonfiguration entity) {
    if(entity == null) {
      setEntityPK(null);
    } else {
      setEntityPK(entity.getPk());
    }
  }

  public
    de.ivu.elect.business.stimmeingabe.entity.StimmeingabePlausiKonfigurationPK
   getEntityPK() {
    return conversationStore.getEntityPK();
  }

  public void setEntityPK(
    de.ivu.elect.business.stimmeingabe.entity.StimmeingabePlausiKonfigurationPK
   entityPK) {
    conversationStore.setEntityPK(entityPK);
  }

  protected StimmeingabePlausiKonfiguration attach(StimmeingabePlausiKonfiguration entity) {
    if (entity == null){
      return null;
    }

    return attach(entity.getPk());
  }

  protected StimmeingabePlausiKonfiguration attach( de.ivu.elect.business.stimmeingabe.entity.StimmeingabePlausiKonfigurationPK  pk) {
    if (pk == null) {
      return null;
    }

    return entityDAO.findByPrimaryKey(pk);
  }

  public void clearEntity() {
    setEntityPK(null);

    conversationStore.close();
  }
}
